package org.tsutils;

import java.util.Date;

public abstract class AbstractTimestamper implements Timestamper {
	
	private final long startTime;
	private final long startTimestamp;
	
	public AbstractTimestamper() {
		this.startTime = System.currentTimeMillis() * 1000000L;
		this.startTimestamp = nanoTime();
	}
	
	@Override
	public final long nanoEpoch() {
		long diff = nanoTime() - startTimestamp;
		return startTime + diff;
	}
	
	@Override
	public final long millisEpoch() {
		return nanoEpoch() / 1000000L;
	}
	
	@Override
	public final Date now() {
		return new Date(millisEpoch());
	}
}